import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class BoardDisplay extends JPanel {
    public BoardDisplay(int gridSize, Icon buttonIcon) {
        super(new GridLayout(gridSize + 1, gridSize + 1)); // +1 wegen extra Zeile/Splate

        // Erstellung von Spielfeld
        for (int i = 0; i <= gridSize; i++) {
            for (int j = 0; j <= gridSize; j++) {
                if (i == 0 && j == 0) {
                    add(new JLabel(" "));
                } else if (i == 0) {
                    JLabel colLabel = new JLabel(String.valueOf(j));
                    colLabel.setHorizontalAlignment(SwingConstants.CENTER);
                    colLabel.setFont(new Font("Arial", Font.BOLD, 14));
                    add(colLabel);
                } else if (j == 0) {
                    JLabel rowLabel = new JLabel(String.valueOf((char) ('A' + i - 1)));
                    rowLabel.setHorizontalAlignment(SwingConstants.CENTER);
                    rowLabel.setFont(new Font("Arial", Font.BOLD, 14));
                    add(rowLabel);
                } else {
                    // Spielfeld (interaktive Zellen)
                    JButton field = new JButton("");
                    field.setBackground(Color.LIGHT_GRAY);
                    field.setOpaque(true);
                    field.setBorderPainted(true);

                    field.addMouseListener(new MouseAdapter() {
                        @Override
                        public void mouseClicked(MouseEvent e) {
                            if(SwingUtilities.isRightMouseButton(e)) {
                                handleFieldClick(field);
                            }
                        }

                        @Override
                        public void mouseExited(MouseEvent e) {
                           // field.setBackground(Color.LIGHT_GRAY);
                        }
                    });
                    add(field);
                }
            }
        }
    }

    private void handleFieldClick(JButton field) {
        field.setBackground(Color.RED);
    }
}