import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

// TODO
// Evtl. ist Namen selber setzten noch unmöglich
//

public class startLocalGame extends JPanel {
    // Player
    Player p1;
    Player p2;

    // Funktionshilfen
    int semesterCounter = 1; // Semester Counter Label
    String leftPlayerNickname = "Spieler 1";
    String rightPlayerNickname = "Einfach";

    // Grafiken
    ImageIcon backButtonIcon = new ImageIcon("graphics/backButton.png");
    ImageIcon humanPlayerIcon = new ImageIcon("graphics/humanPlayer.png");
    ImageIcon aiPlayerEasyIcon = new ImageIcon("graphics/botPlayerEasy.png");
    ImageIcon aiPlayerNormalIcon = new ImageIcon("graphics/botPlayerNormal.png");
    ImageIcon aiPlayerHardIcon = new ImageIcon("graphics/botPlayerHard.png");

    // Labels und Buttons
    JLabel frameTitle = new JLabel("Lokales Spiel");
    JLabel semesterLabel = new JLabel("Semester");
    JLabel leftPlayerName = new JLabel("Name");
    JLabel rightPlayerName = new JLabel("KI-Level");
    JLabel leftPlayerIcon = new JLabel(humanPlayerIcon);
    JLabel rightPlayerIcon = new JLabel(aiPlayerEasyIcon);
    JLabel semesterCounterLabel = new JLabel(String.valueOf(semesterCounter));

    JButton backButton = new JButton(backButtonIcon);
    JButton leftPlayerLeftButton = new JButton("<-");
    JButton leftPlayerRightButton = new JButton("->");
    JButton semesterUpButton = new JButton("^");
    JButton semesterDownButton = new JButton("v");
    JButton rightPlayerLeftButton = new JButton("<-");
    JButton rightPlayerRightButton = new JButton("->");
    JButton startButton = new JButton("Start!");
    JButton testButton = new JButton("Test");

    JTextField leftPlayerTextField = new JTextField(20);
    JTextField rightPlayerTextField = new JTextField(20);

    // Methode zur Erstellung des Panels
    startLocalGame(MainFrame frame) {
        setLayout(null);  // Stelle das Layout des Panels ein

        // Setze Komponentenpositionen
        frameTitle.setBounds(20, 20, 200, 30);
        add(frameTitle);

        semesterLabel.setBounds(700, 300, 200, 30);
        add(semesterLabel);

        leftPlayerName.setBounds(50, 625, 200, 30);
        add(leftPlayerName);

        rightPlayerName.setBounds(1200, 625, 200, 30);
        add(rightPlayerName);

        leftPlayerIcon.setBounds(75, 400, 200, 128);
        add(leftPlayerIcon);

        rightPlayerIcon.setBounds(1225, 400, 200, 128);
        add(rightPlayerIcon);

        semesterCounterLabel.setBounds(725, 475, 50, 50);
        semesterCounterLabel.setHorizontalAlignment(SwingConstants.CENTER);
        add(semesterCounterLabel);

        testButton.setBounds(500,800,50,50);
        add(testButton);

        backButton.setBounds(1380, 20, 80, 80);
        add(backButton);

        leftPlayerLeftButton.setBounds(50, 450, 50, 50);
        add(leftPlayerLeftButton);

        leftPlayerRightButton.setBounds(250, 450, 50, 50);
        add(leftPlayerRightButton);

        semesterUpButton.setBounds(725, 400, 50, 50);
        add(semesterUpButton);

        semesterDownButton.setBounds(725, 550, 50, 50);
        add(semesterDownButton);

        rightPlayerLeftButton.setBounds(1200, 450, 50, 50);
        add(rightPlayerLeftButton);

        rightPlayerRightButton.setBounds(1400, 450, 50, 50);
        add(rightPlayerRightButton);

        startButton.setBounds(700, 750, 100, 50);
        add(startButton);

        leftPlayerTextField.setBounds(50, 650, 250, 50);
        leftPlayerTextField.setText(leftPlayerNickname);
        add(leftPlayerTextField);

        rightPlayerTextField.setBounds(1200, 650, 250, 50);
        rightPlayerTextField.setText(rightPlayerNickname);
        add(rightPlayerTextField);


        // ActionListener für Buttons
        semesterUpButton.addActionListener(e -> {
            if (semesterCounter < 6) {
                semesterCounter++;
                semesterCounterLabel.setText(String.valueOf(semesterCounter));
            }
        });

        semesterDownButton.addActionListener(e -> {
            if (semesterCounter > 1) {
                semesterCounter--;
                semesterCounterLabel.setText(String.valueOf(semesterCounter));
            }
        });

        leftPlayerLeftButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                toggleLeftPlayerIconLeft();
                updateTextFields();
            }
        });

        leftPlayerRightButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                toggleLeftPlayerIconRight();
                updateTextFields();
            }
        });

        rightPlayerLeftButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                toggleRightPlayerIconLeft();
                updateTextFields();
            }
        });

        rightPlayerRightButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                toggleRightPlayerIconRight();
                updateTextFields();
            }
        });

        backButton.addActionListener(e -> frame.showPanel("MainMenu"));
        testButton.addActionListener(e -> frame.showPanelSLG("GameBoard",1,p1,p2));
        //startButton.addActionListener(e -> frame.showPanelSLG("GameBoard", semesterCounter,p1, p2)); // TODO ECHTE FUNKTION EINFÜGEN
        startButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                frame.showPanelSLGLS("startLocalGameLoadingScreen", semesterCounter); //TODO
                if (leftPlayerIcon.getIcon() == humanPlayerIcon) {// TODO Wird name wirklich weitergegeben?
                    if (rightPlayerIcon.getIcon() == aiPlayerEasyIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerEasy.class, GameController.semesterToBoardSize(semesterCounter));
                    } else if (rightPlayerIcon.getIcon() == aiPlayerNormalIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerMedium.class, GameController.semesterToBoardSize(semesterCounter));
                    } else if (rightPlayerIcon.getIcon() == aiPlayerHardIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerHard.class, GameController.semesterToBoardSize(semesterCounter));
                    }
                } else if (leftPlayerIcon.getIcon() == aiPlayerEasyIcon) {
                    if (rightPlayerIcon.getIcon() == aiPlayerEasyIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerEasy.class, GameController.semesterToBoardSize(semesterCounter));
                    } else if (rightPlayerIcon.getIcon() == aiPlayerNormalIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerMedium.class, GameController.semesterToBoardSize(semesterCounter));
                    } else if (rightPlayerIcon.getIcon() == aiPlayerHardIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerHard.class, GameController.semesterToBoardSize(semesterCounter));
                    }
                } else if (rightPlayerIcon.getIcon() == aiPlayerNormalIcon) {
                    if (rightPlayerIcon.getIcon() == aiPlayerEasyIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerEasy.class, GameController.semesterToBoardSize(semesterCounter));
                    } else if (rightPlayerIcon.getIcon() == aiPlayerNormalIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerMedium.class, GameController.semesterToBoardSize(semesterCounter));
                    } else if (rightPlayerIcon.getIcon() == aiPlayerHardIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerHard.class, GameController.semesterToBoardSize(semesterCounter));
                    }
                } else if (rightPlayerIcon.getIcon() == aiPlayerHardIcon) {
                    if (rightPlayerIcon.getIcon() == aiPlayerEasyIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerEasy.class, GameController.semesterToBoardSize(semesterCounter));
                    } else if (rightPlayerIcon.getIcon() == aiPlayerNormalIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerMedium.class, GameController.semesterToBoardSize(semesterCounter));
                    } else if (rightPlayerIcon.getIcon() == aiPlayerHardIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerHard.class, GameController.semesterToBoardSize(semesterCounter));
                    }
                }

            }
        });

    }

    private void toggleLeftPlayerIconLeft() {
        if (leftPlayerIcon.getIcon() == humanPlayerIcon) {
            leftPlayerIcon.setIcon(aiPlayerHardIcon);
        } else if (leftPlayerIcon.getIcon() == aiPlayerEasyIcon){
            leftPlayerIcon.setIcon(humanPlayerIcon);
        } else if (leftPlayerIcon.getIcon() == aiPlayerNormalIcon) {
            leftPlayerIcon.setIcon(aiPlayerEasyIcon);
        } else if (leftPlayerIcon.getIcon() == aiPlayerHardIcon) {
            leftPlayerIcon.setIcon(aiPlayerNormalIcon);
        }
    }

    private void toggleLeftPlayerIconRight() {
        if (leftPlayerIcon.getIcon() == humanPlayerIcon) {
            leftPlayerIcon.setIcon(aiPlayerEasyIcon);
        } else if (leftPlayerIcon.getIcon() == aiPlayerEasyIcon){
            leftPlayerIcon.setIcon(aiPlayerNormalIcon);
        } else if (leftPlayerIcon.getIcon() == aiPlayerNormalIcon) {
            leftPlayerIcon.setIcon(aiPlayerHardIcon);
        } else if (leftPlayerIcon.getIcon() == aiPlayerHardIcon) {
            leftPlayerIcon.setIcon(humanPlayerIcon);
        }
    }

    private void toggleRightPlayerIconLeft() {
        if (rightPlayerIcon.getIcon() == aiPlayerEasyIcon) {
            rightPlayerIcon.setIcon(aiPlayerHardIcon);
        } else if (rightPlayerIcon.getIcon() == aiPlayerNormalIcon){
            rightPlayerIcon.setIcon(aiPlayerEasyIcon);
        } else if (rightPlayerIcon.getIcon() == aiPlayerHardIcon) {
            rightPlayerIcon.setIcon(aiPlayerNormalIcon);
        }
    }

    private void toggleRightPlayerIconRight() {
        if (rightPlayerIcon.getIcon() == aiPlayerEasyIcon) {
            rightPlayerIcon.setIcon(aiPlayerNormalIcon);
        } else if (rightPlayerIcon.getIcon() == aiPlayerNormalIcon){
            rightPlayerIcon.setIcon(aiPlayerHardIcon);
        } else if (rightPlayerIcon.getIcon() == aiPlayerHardIcon) {
            rightPlayerIcon.setIcon(aiPlayerEasyIcon);
        }
    }

    // Methode zum Aktualisieren der Textfelder basierend auf den ausgewählten Icons
    private void updateTextFields() {
        // Linker Spieler
        if (leftPlayerIcon.getIcon() == humanPlayerIcon) {
            leftPlayerTextField.setText("Spieler 1");
        } else if (leftPlayerIcon.getIcon() == aiPlayerEasyIcon){
            leftPlayerTextField.setText("Einfach");
        } else if (leftPlayerIcon.getIcon() == aiPlayerNormalIcon) {
            leftPlayerTextField.setText("Mittel");
        } else if (leftPlayerIcon.getIcon() == aiPlayerHardIcon) {
            leftPlayerTextField.setText("Schwer");
        }

        // Rechter Spieler
        if (rightPlayerIcon.getIcon() == aiPlayerEasyIcon){
            rightPlayerTextField.setText("Einfach");
        } else if (rightPlayerIcon.getIcon() == aiPlayerNormalIcon) {
            rightPlayerTextField.setText("Mittel");
        } else if (rightPlayerIcon.getIcon() == aiPlayerHardIcon) {
            rightPlayerTextField.setText("Schwer");
        }
    }
}